(define-module (solarpunk packages guile)
  #:use-module (gnu packages)
  #:use-module (gnu packages autotools)
  #:use-module (gnu packages guile)
  #:use-module (gnu packages guile-xyz)
  #:use-module (gnu packages pkg-config)
  #:use-module (gnu packages texinfo)
  #:use-module (guix build-system gnu)
  #:use-module (guix git-download)
  #:use-module (guix gexp)
  #:use-module ((guix licenses) #:prefix license:)
  #:use-module (guix packages)
  #:use-module (srfi srfi-1))

(define-public guile-termenv
  (package
   (name "s")
   (version "0.1")
   (source
    (origin
     (method git-fetch)
     (uri (git-reference
           (url "https://git.solarpunk.moe/solarpunk-guile/guile-termenv.git")
           (commit "v0.1")))
     (sha256
      (base32
       "1cs5vs3inc2a43hijgw9krg0a10v060hmdynkmrzm4kbnig5qraw"))))
   (build-system gnu-build-system)
   (arguments
    (list
     #:make-flags
     #~(list "GUILE_AUTO_COMPILE=0")
     #:phases
     #~(modify-phases %standard-phases
                      (add-before 'bootstrap 'hall
                                  (lambda _
	                                  (system* "hall" "build" "-x")))
	                    (replace 'bootstrap
                               (lambda _
	                               (system* "autoreconf" "-vif"))))))
   (native-inputs (list autoconf
			                  automake
			                  guile-hall
			                  pkg-config
			                  texinfo))
   (inputs (list guile-3.0))
   (synopsis "Guile port of termenv")
   (description
    "A library to provide easy control of terminals from Guile using terminal control codes.")
   (home-page "https://git.solarpunk.moe/solarpunk-guile/guile-termenv")
   (license license:gpl3+)))

(define-public guile-uniseg
  (package
   (name "guile-uniseg")
   (version "0.1")
   (source
    (origin
     (method git-fetch)
     (uri (git-reference
           (url "https://git.solarpunk.moe/solarpunk-guile/guile-uniseg.git")
           (commit "v0.1")))
     (sha256
      (base32
       "01capcnw3khqcymh1r4wxlm6sml4wfn9lv30nplk8fwc60pyb4d8"))))
   (build-system gnu-build-system)
   (arguments
    (list
     #:make-flags
     #~(list "GUILE_AUTO_COMPILE=0")
     #:phases
     #~(modify-phases %standard-phases
                      (add-before 'bootstrap 'hall
                                  (lambda _
	                                  (system* "hall" "build" "-x")))
	                    (replace 'bootstrap
                               (lambda _
	                               (system* "autoreconf" "-vif"))))))
   (native-inputs (list autoconf
			                  automake
			                  guile-hall
			                  pkg-config
			                  texinfo))
   (inputs (list guile-3.0))
   (synopsis "Guile library for utf-8 rune widths")
   (description
    "A library that provides guile character sets and operations to work with runes that are more than a single character width.")
   (home-page "https://git.solarpunk.moe/solarpunk-guile/guile-uniseg")
   (license license:gpl3+)))
